
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Exempt_incomesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const exempt_incomes = await db.exempt_incomes.create(
            {
                id: data.id || undefined,
        
        income_type: data.income_type
        ||
        null
            ,
            
        source_name: data.source_name
        ||
        null
            ,
            
        source_document: data.source_document
        ||
        null
            ,
            
        amount: data.amount
        ||
        null
            ,
            
        competence: data.competence
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await exempt_incomes.setDeclaration( data.declaration || null, {
            transaction,
        });
        
        await exempt_incomes.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return exempt_incomes;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const exempt_incomesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                income_type: item.income_type
            ||
            null
            ,
            
                source_name: item.source_name
            ||
            null
            ,
            
                source_document: item.source_document
            ||
            null
            ,
            
                amount: item.amount
            ||
            null
            ,
            
                competence: item.competence
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const exempt_incomes = await db.exempt_incomes.bulkCreate(exempt_incomesData, { transaction });

        // For each item created, replace relation files
        

        return exempt_incomes;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const exempt_incomes = await db.exempt_incomes.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.income_type !== undefined) updatePayload.income_type = data.income_type;
        
        
        if (data.source_name !== undefined) updatePayload.source_name = data.source_name;
        
        
        if (data.source_document !== undefined) updatePayload.source_document = data.source_document;
        
        
        if (data.amount !== undefined) updatePayload.amount = data.amount;
        
        
        if (data.competence !== undefined) updatePayload.competence = data.competence;
        
        
        updatePayload.updatedById = currentUser.id;

        await exempt_incomes.update(updatePayload, {transaction});

        
        
        if (data.declaration !== undefined) {
            await exempt_incomes.setDeclaration(
              
              data.declaration,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await exempt_incomes.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return exempt_incomes;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const exempt_incomes = await db.exempt_incomes.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of exempt_incomes) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of exempt_incomes) {
                await record.destroy({transaction});
            }
        });


        return exempt_incomes;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const exempt_incomes = await db.exempt_incomes.findByPk(id, options);

        await exempt_incomes.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await exempt_incomes.destroy({
            transaction
        });

        return exempt_incomes;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const exempt_incomes = await db.exempt_incomes.findOne(
            { where },
            { transaction },
        );

        if (!exempt_incomes) {
            return exempt_incomes;
        }

        const output = exempt_incomes.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.declaration = await exempt_incomes.getDeclaration({
            transaction
        });
        
        
        output.organizations = await exempt_incomes.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.declarations,
        as: 'declaration',
        
        where: filter.declaration ? {
          [Op.or]: [
            { id: { [Op.in]: filter.declaration.split('|').map(term => Utils.uuid(term)) } },
            {
              status: {
                [Op.or]: filter.declaration.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.source_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'exempt_incomes',
                        'source_name',
                        filter.source_name,
                    ),
                };
            }
            
            if (filter.source_document) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'exempt_incomes',
                        'source_document',
                        filter.source_document,
                    ),
                };
            }
            
            if (filter.competence) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'exempt_incomes',
                        'competence',
                        filter.competence,
                    ),
                };
            }
            

            
            

            
            if (filter.amountRange) {
                const [start, end] = filter.amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.income_type) {
                where = {
                    ...where,
                income_type: filter.income_type,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.exempt_incomes.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'exempt_incomes',
                        'source_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.exempt_incomes.findAll({
            attributes: [ 'id', 'source_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['source_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.source_name,
        }));
    }

    
};

